import { __values } from "tslib";
import * as ExcelJS from 'exceljs';
var JsExcelTemplateBase = /** @class */ (function () {
    function JsExcelTemplateBase() {
        this.workbook = new ExcelJS.Workbook();
    }
    JsExcelTemplateBase.prototype.set = function (name, value, options) {
        var e_1, _a, e_2, _b;
        var _this = this;
        if (Array.isArray(value)) {
            if (value.length === 0) {
                return;
            }
            var _loop_1 = function (sheet) {
                sheet.eachRow(function (row, rowIndex) {
                    var rowDuplicated = false;
                    var duplicateAndSetCell = function (text, columnIndex) {
                        var e_3, _a;
                        var fieldNames = _this.getFieldNames(text, name);
                        try {
                            for (var fieldNames_1 = (e_3 = void 0, __values(fieldNames)), fieldNames_1_1 = fieldNames_1.next(); !fieldNames_1_1.done; fieldNames_1_1 = fieldNames_1.next()) {
                                var fieldName = fieldNames_1_1.value;
                                if (options === null || options === void 0 ? void 0 : options.duplicateCellIfArray) {
                                    if (!rowDuplicated) {
                                        for (var i = 1; i < value.length; i++) {
                                            row.getCell(columnIndex + i).value = row.getCell(columnIndex).value;
                                        }
                                        rowDuplicated = true;
                                    }
                                    for (var i = 0; i < value.length; i++) {
                                        _this.setCell(row.getCell(columnIndex + i), "{".concat(name, ".").concat(fieldName, "}"), value[i][fieldName]);
                                    }
                                }
                                else {
                                    if (!rowDuplicated) {
                                        if (value.length > 1) {
                                            sheet.duplicateRow(rowIndex, value.length - 1, true);
                                        }
                                        rowDuplicated = true;
                                    }
                                    for (var i = 0; i < value.length; i++) {
                                        _this.setCell(sheet.getRow(rowIndex + i).getCell(columnIndex), "{".concat(name, ".").concat(fieldName, "}"), value[i][fieldName]);
                                    }
                                }
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (fieldNames_1_1 && !fieldNames_1_1.done && (_a = fieldNames_1.return)) _a.call(fieldNames_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                    };
                    row.eachCell(function (cell, columnIndex) {
                        var e_4, _a;
                        if (typeof cell.value === 'string') {
                            duplicateAndSetCell(cell.value, columnIndex);
                        }
                        else if (typeof cell.value === 'object' && cell.value) {
                            var richTextCell = cell.value;
                            if (richTextCell.richText && Array.isArray(richTextCell.richText)) {
                                try {
                                    for (var _b = (e_4 = void 0, __values(richTextCell.richText)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                        var richText = _c.value;
                                        duplicateAndSetCell(richText.text, columnIndex);
                                    }
                                }
                                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                                finally {
                                    try {
                                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                                    }
                                    finally { if (e_4) throw e_4.error; }
                                }
                            }
                        }
                    });
                });
            };
            try {
                for (var _c = __values(this.workbook.worksheets), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var sheet = _d.value;
                    _loop_1(sheet);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else {
            try {
                for (var _e = __values(this.workbook.worksheets), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var sheet = _f.value;
                    sheet.eachRow(function (row) {
                        row.eachCell(function (cell) {
                            _this.setCell(cell, "{".concat(name, "}"), value);
                        });
                    });
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
    };
    JsExcelTemplateBase.prototype.toArrayBuffer = function () {
        return this.workbook.xlsx.writeBuffer();
    };
    JsExcelTemplateBase.prototype.getFieldNames = function (text, name) {
        var fieldNames = [];
        var position = 0;
        while (position >= 0 && position < text.length) {
            var index = text.indexOf("{".concat(name, "."), position);
            if (index >= 0) {
                var endIndex = text.indexOf('}', index + "{".concat(name, ".").length);
                if (endIndex >= 0) {
                    fieldNames.push(text.substring(index + "{".concat(name, ".").length, endIndex));
                    position = endIndex;
                }
                else {
                    break;
                }
            }
            else {
                break;
            }
        }
        return fieldNames;
    };
    JsExcelTemplateBase.prototype.setCell = function (cell, name, value) {
        var e_5, _a;
        if (cell.value) {
            if (typeof cell.value === 'string') {
                if (cell.value.includes(name)) {
                    cell.value = cell.value === name ? value : cell.value.split(name).join(String(value));
                }
            }
            else if (typeof cell.value === 'object') {
                var richTextCell = cell.value;
                if (richTextCell.richText && Array.isArray(richTextCell.richText)) {
                    try {
                        for (var _b = __values(richTextCell.richText), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var richText = _c.value;
                            if (richText.text.includes(name)) {
                                richText.text = richText.text === name ? String(value) : richText.text.split(name).join(String(value));
                            }
                        }
                    }
                    catch (e_5_1) { e_5 = { error: e_5_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_5) throw e_5.error; }
                    }
                }
            }
        }
    };
    return JsExcelTemplateBase;
}());
export default JsExcelTemplateBase;
