"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const common_1 = tslib_1.__importDefault(require("./common"));
/**
 * @public
 */
class JsExcelTemplate extends common_1.default {
    static async fromFile(filepath) {
        const template = new JsExcelTemplate();
        await template.workbook.xlsx.readFile(filepath);
        return template;
    }
    async toBuffer() {
        const arrayBuffer = await this.toArrayBuffer();
        return Buffer.from(arrayBuffer);
    }
    saveAs(filepath) {
        return this.workbook.xlsx.writeFile(filepath);
    }
}
exports.default = JsExcelTemplate;
